; The Best Damn Sprite Routine Period (AND Version)
; 
; AUTHOR: Sean McLaughlin (sigma_zk@yahoo.com)
;
; DESCRIPTION:
;	ANDs a sprite to PlotSScreen with clipping.
;
; INPUT:
;	D	Abscissa
;	E	Ordinate
;	HL	Pointer to start of sprite data:
;		number of rows; sprite row 1; sprite row 2; et cetera.
; DESTROYS:
;	AF BC DE HL IX
;	Interrupts are disabled
;
.MODULE	_TBDSRP_A
#define	A_PIXEL_SHIFT	.DB $CB,$31,$17		; SLL C\ RLA
ClipSprite_AND:
	LD	B,(HL)
	LD	A,E
	CP	$80
	JR	C,_PosY
	NEG
	CP	B
	RET	P
	LD	C,A
	NEG
	ADD	A,B
	LD	B,0
	ADD	HL,BC
	LD	E,B
	LD	B,A
_PosY:
	CP	64
	RET	NC
_ClipBtm:
	ADD	A,B
	SUB	65
	JR	C,_DoHoriz
	SUB	B
	CPL
	LD	B,A
_DoHoriz:
	LD	A,D
	CP	$80
	JR	C,_PosX
	CP	-7
	RET	C
	LD	IX,_ClipLeft
	JR	_Patch
_PosX:
	CP	96
	RET	NC
	CP	89
	LD	IX,_ClipRight
	JR	C,_DoSprite
_Patch:
	LD	(IX),0
_DoSprite:
	DI
	INC	HL
	PUSH	HL
	SLA	E
	SLA	E
	LD	H,0
	LD	L,E
	LD	D,H
	ADD	HL,HL
	ADD	HL,DE
	LD	E,A
	SRA	E
	SRA	E
	SRA	E
	JP	P,_Pos
	DEC	D
_Pos:
	ADD	HL,DE
	LD	DE,PlotSScreen
	ADD	HL,DE
	POP	DE
	AND	7
	LD	(_save),SP
	LD	SP,11
	JR	Z,_Aligned
	DEC	A
	LD	C,A
	ADD	A,A
	ADD	A,C
	LD	(_Jump),A
_Loop:
	LD	A,(DE)
	LD	C,A
	LD	A,$FF
_Jump	=$+1
	JR	$
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	AND	(HL)
_ClipLeft:
	LD	(HL),A
	INC	HL
	LD	A,C
	AND	(HL)
_ClipRight:
	LD	(HL),A
	INC	DE
	ADD	HL,SP
	DJNZ	_Loop
	LD	(IX),$77
_Done:
_save	=$+1
	LD	SP,0
	RET
_Aligned:
	INC	SP
_ALoop:
	LD	A,(DE)
	AND	(HL)
	LD	(HL),A
	INC	DE
	ADD	HL,SP
	DJNZ	_ALoop
	JP	_Done
